Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/IPTC.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/IPTC.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/IPTC.pm	(revision 34921)
@@ -14,6 +14,7 @@
 use strict;
 use vars qw($VERSION $AUTOLOAD %iptcCharset);
-
-$VERSION = '1.42';
+use Image::ExifTool qw(:DataAccess :Utils);
+
+$VERSION = '1.57';
 
 %iptcCharset = (
@@ -32,4 +33,24 @@
 sub PrintCodedCharset($);
 sub PrintInvCodedCharset($);
+
+# standard IPTC locations
+# (MWG specifies locations only for JPEG, TIFF and PSD -- the rest are ExifTool-defined)
+my %isStandardIPTC = (
+    'JPEG-APP13-Photoshop-IPTC' => 1,
+    'TIFF-IFD0-IPTC'            => 1,
+    'PSD-IPTC'                  => 1,
+    'MIE-IPTC'                  => 1,
+    'EPS-Photoshop-IPTC'        => 1,
+    'PS-Photoshop-IPTC'         => 1,
+    'EXV-APP13-Photoshop-IPTC'  => 1,
+    # set file types to 0 if they have a standard location
+    JPEG => 0,
+    TIFF => 0,
+    PSD  => 0,
+    MIE  => 0,
+    EPS  => 0,
+    PS   => 0,
+    EXV  => 0,
+);
 
 my %fileFormat = (
@@ -182,4 +203,5 @@
         ValueConv => 'Image::ExifTool::Exif::ExifDate($val)',
         ValueConvInv => 'Image::ExifTool::IPTC::IptcDate($val)',
+        PrintConvInv => 'Image::ExifTool::IPTC::InverseDateOrTime($self,$val)',
     },
     80 => {
@@ -190,4 +212,5 @@
         ValueConv => 'Image::ExifTool::Exif::ExifTime($val)',
         ValueConvInv => 'Image::ExifTool::IPTC::IptcTime($val)',
+        PrintConvInv => 'Image::ExifTool::IPTC::InverseDateOrTime($self,$val)',
     },
     90 => {
@@ -206,4 +229,5 @@
         Protected => 1,
         Format => 'string[0,32]',
+        ValueConvInv => '$val =~ /^UTF-?8$/i ? "\x1b%G" : $val',
         # convert ISO 2022 escape sequences to a more readable format
         PrintConv => \&PrintCodedCharset,
@@ -317,4 +341,5 @@
         ValueConv => 'Image::ExifTool::Exif::ExifDate($val)',
         ValueConvInv => 'Image::ExifTool::IPTC::IptcDate($val)',
+        PrintConvInv => 'Image::ExifTool::IPTC::InverseDateOrTime($self,$val)',
     },
     35 => {
@@ -325,4 +350,5 @@
         ValueConv => 'Image::ExifTool::Exif::ExifTime($val)',
         ValueConvInv => 'Image::ExifTool::IPTC::IptcTime($val)',
+        PrintConvInv => 'Image::ExifTool::IPTC::InverseDateOrTime($self,$val)',
     },
     37 => {
@@ -333,4 +359,5 @@
         ValueConv => 'Image::ExifTool::Exif::ExifDate($val)',
         ValueConvInv => 'Image::ExifTool::IPTC::IptcDate($val)',
+        PrintConvInv => 'Image::ExifTool::IPTC::InverseDateOrTime($self,$val)',
     },
     38 => {
@@ -341,4 +368,5 @@
         ValueConv => 'Image::ExifTool::Exif::ExifTime($val)',
         ValueConvInv => 'Image::ExifTool::IPTC::IptcTime($val)',
+        PrintConvInv => 'Image::ExifTool::IPTC::InverseDateOrTime($self,$val)',
     },
     40 => {
@@ -353,5 +381,5 @@
             '01' => 'Object Kill',
             '02' => 'Object Replace',
-            '03' => 'Ojbect Append',
+            '03' => 'Object Append',
             '04' => 'Object Reference',
         },
@@ -370,4 +398,5 @@
         ValueConv => 'Image::ExifTool::Exif::ExifDate($val)',
         ValueConvInv => 'Image::ExifTool::IPTC::IptcDate($val)',
+        PrintConvInv => 'Image::ExifTool::IPTC::InverseDateOrTime($self,$val)',
     },
     50 => {
@@ -383,4 +412,5 @@
         ValueConv => 'Image::ExifTool::Exif::ExifDate($val)',
         ValueConvInv => 'Image::ExifTool::IPTC::IptcDate($val)',
+        PrintConvInv => 'Image::ExifTool::IPTC::InverseDateOrTime($self,$val)',
     },
     60 => {
@@ -391,4 +421,5 @@
         ValueConv => 'Image::ExifTool::Exif::ExifTime($val)',
         ValueConvInv => 'Image::ExifTool::IPTC::IptcTime($val)',
+        PrintConvInv => 'Image::ExifTool::IPTC::InverseDateOrTime($self,$val)',
     },
     62 => {
@@ -399,4 +430,5 @@
         ValueConv => 'Image::ExifTool::Exif::ExifDate($val)',
         ValueConvInv => 'Image::ExifTool::IPTC::IptcDate($val)',
+        PrintConvInv => 'Image::ExifTool::IPTC::InverseDateOrTime($self,$val)',
     },
     63 => {
@@ -407,4 +439,5 @@
         ValueConv => 'Image::ExifTool::Exif::ExifTime($val)',
         ValueConvInv => 'Image::ExifTool::IPTC::IptcTime($val)',
+        PrintConvInv => 'Image::ExifTool::IPTC::InverseDateOrTime($self,$val)',
     },
     65 => {
@@ -465,4 +498,5 @@
         Name => 'OriginalTransmissionReference',
         Format => 'string[0,32]',
+        Notes => 'now used as a job identifier',
     },
     105 => {
@@ -502,5 +536,5 @@
             225-232, so I have just make them writable as strings with
             reasonable length.  Beware that if this is wrong, other utilities
-            won't be able to read these tags as written by ExifTool
+            may not be able to read these tags as written by ExifTool
         },
     },
@@ -607,5 +641,5 @@
     202 => {
         Name => 'ObjectPreviewData',
-        Groups => { 2 => 'Image' },
+        Groups => { 2 => 'Preview' },
         Format => 'undef[0,256000]',
         Binary => 1,
@@ -642,4 +676,6 @@
         Name => 'DocumentHistory',
         Format => 'string[0,256]', # (guess)
+        ValueConv => '$val =~ s/\0+/\n/g; $val', # (have seen embedded nulls)
+        ValueConvInv => '$val',
     },
     232 => {
@@ -954,5 +990,5 @@
 sub HandleCodedCharset($$)
 {
-    my ($exifTool, $val) = @_;
+    my ($et, $val) = @_;
     my $xlat = $iptcCharset{$val};
     unless ($xlat) {
@@ -961,9 +997,9 @@
             $xlat = 'bad';  # flag unsupported coding
         } else {
-            $xlat = $exifTool->Options('CharsetIPTC');
+            $xlat = $et->Options('CharsetIPTC');
         }
     }
     # no need to translate if Charset is the same
-    undef $xlat if $xlat eq $exifTool->Options('Charset');
+    undef $xlat if $xlat eq $et->Options('Charset');
     return $xlat;
 }
@@ -976,15 +1012,15 @@
 sub TranslateCodedString($$$$)
 {
-    my ($exifTool, $valPtr, $xlatPtr, $read) = @_;
+    my ($et, $valPtr, $xlatPtr, $read) = @_;
     if ($$xlatPtr eq 'bad') {
-        $exifTool->Warn('Some IPTC characters not converted (unsupported CodedCharacterSet)');
+        $et->Warn('Some IPTC characters not converted (unsupported CodedCharacterSet)');
         undef $$xlatPtr;
     } elsif (not $read) {
-        $$valPtr = $exifTool->Decode($$valPtr, undef, undef, $$xlatPtr);
+        $$valPtr = $et->Decode($$valPtr, undef, undef, $$xlatPtr);
     } elsif ($$valPtr !~ /[\x14\x15\x1b]/) {
-        $$valPtr = $exifTool->Decode($$valPtr, $$xlatPtr);
+        $$valPtr = $et->Decode($$valPtr, $$xlatPtr);
     } else {
         # don't yet support reading ISO 2022 shifted character sets
-        $exifTool->WarnOnce('Some IPTC characters not converted (ISO 2022 shifting not supported)');
+        $et->WarnOnce('Some IPTC characters not converted (ISO 2022 shifting not supported)');
     }
 }
@@ -993,9 +1029,12 @@
 # Is this IPTC in a standard location?
 # Inputs: 0) Current metadata path string
-# Returns: true if path is standard
+# Returns: true if path is standard, 0 if file type doesn't have standard IPTC,
+#          or undef if IPTC is non-standard
 sub IsStandardIPTC($)
 {
     my $path = shift;
-    return $path =~ /^(JPEG-APP13-Photoshop-IPTC|TIFF-IFD0-IPTC|PSD-IPTC|MIE-IPTC)$/
+    return 1 if $isStandardIPTC{$path};
+    return 0 unless $path =~ /^(\w+)/ and defined $isStandardIPTC{$1};
+    return undef;   # non-standard
 }
 
@@ -1007,44 +1046,59 @@
 sub ProcessIPTC($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $pos = $$dirInfo{DirStart} || 0;
     my $dirLen = $$dirInfo{DirLen} || 0;
     my $dirEnd = $pos + $dirLen;
-    my $verbose = $exifTool->Options('Verbose');
+    my $verbose = $et->Options('Verbose');
+    my $validate = $et->Options('Validate');
     my $success = 0;
     my ($lastRec, $recordPtr, $recordName);
 
-    $verbose and $dirInfo and $exifTool->VerboseDir('IPTC', 0, $$dirInfo{DirLen});
+    $verbose and $dirInfo and $et->VerboseDir('IPTC', 0, $$dirInfo{DirLen});
 
     if ($tagTablePtr eq \%Image::ExifTool::IPTC::Main) {
-        # calculate MD5 if Digest::MD5 is available (for standard IPTC only)
-        my $path = $exifTool->MetadataPath();
-        if (IsStandardIPTC($path)) {
-            my $md5;
-            if (eval 'require Digest::MD5') {
-                if ($pos or $dirLen != length($$dataPt)) {
-                    $md5 = Digest::MD5::md5(substr $$dataPt, $pos, $dirLen);
+        my $path = $et->MetadataPath();
+        my $isStd = IsStandardIPTC($path);
+        if (defined $isStd and not $$et{DIR_COUNT}{STD_IPTC}) {
+            # set flag to ensure we only have one family 1 "IPTC" group
+            $$et{DIR_COUNT}{STD_IPTC} = 1;
+            # calculate MD5 if Digest::MD5 is available (truly standard IPTC only)
+            if ($isStd) {
+                my $md5;
+                if (eval { require Digest::MD5 }) {
+                    if ($pos or $dirLen != length($$dataPt)) {
+                        $md5 = Digest::MD5::md5(substr $$dataPt, $pos, $dirLen);
+                    } else {
+                        $md5 = Digest::MD5::md5($$dataPt);
+                    }
                 } else {
-                    $md5 = Digest::MD5::md5($$dataPt);
+                    # a zero digest indicates IPTC exists but we don't have Digest::MD5
+                    $md5 = "\0" x 16;
                 }
-            } else {
-                # a zero digest indicates IPTC exists but we don't have Digest::MD5
-                $md5 = "\0" x 16;
+                $et->FoundTag('CurrentIPTCDigest', $md5);
             }
-            $exifTool->FoundTag('CurrentIPTCDigest', $md5);
-        } elsif ($Image::ExifTool::MWG::strict and $$exifTool{FILE_TYPE} =~ /^(JPEG|TIFF|PSD)$/) {
-            # ignore non-standard IPTC while in strict MWG compatibility mode
-            $exifTool->Warn("Ignored non-standard IPTC at $path");
-            return 1;
+        } else {
+            if (($Image::ExifTool::MWG::strict or $et->Options('Validate')) and
+                $$et{FILE_TYPE} =~ /^(JPEG|TIFF|PSD)$/)
+            {
+                if ($Image::ExifTool::MWG::strict) {
+                    # ignore non-standard IPTC while in strict MWG compatibility mode
+                    $et->Warn("Ignored non-standard IPTC at $path");
+                    return 1;
+                } else {
+                    $et->Warn("Non-standard IPTC at $path", 1);
+                }
+            }
+            # extract non-standard IPTC
+            my $count = ($$et{DIR_COUNT}{IPTC} || 0) + 1;  # count non-standard IPTC
+            $$et{DIR_COUNT}{IPTC} = $count;
+            $$et{LOW_PRIORITY_DIR}{IPTC} = 1;       # lower priority of non-standard IPTC
+            $$et{SET_GROUP1} = '+' . ($count + 1);  # add number to family 1 group name
         }
-        # set family 1 group name if multiple IPTC directories
-        my $dirCount = ($exifTool->{DIR_COUNT}->{IPTC} || 0) + 1;
-        $exifTool->{DIR_COUNT}->{IPTC} = $dirCount;
-        $exifTool->{SET_GROUP1} = '+' . $dirCount if $dirCount > 1;
     }
     # begin by assuming default IPTC encoding
-    my $xlat = $exifTool->Options('CharsetIPTC');
-    undef $xlat if $xlat eq $exifTool->Options('Charset');
+    my $xlat = $et->Options('CharsetIPTC');
+    undef $xlat if $xlat eq $et->Options('Charset');
 
     # quick check for improperly byte-swapped IPTC
@@ -1052,5 +1106,5 @@
                          substr($$dataPt, $pos + 3, 1) eq "\x1c")
     {
-        $exifTool->Warn('IPTC data was improperly byte-swapped');
+        $et->Warn('IPTC data was improperly byte-swapped');
         my $newData = pack('N*', unpack('V*', substr($$dataPt, $pos, $dirLen) . "\0\0\0"));
         $dataPt = \$newData;
@@ -1058,4 +1112,14 @@
         $dirEnd = $pos + $dirLen;
         # NOTE: MUST NOT access $dirInfo DataPt, DirStart or DataLen after this!
+    }
+    # extract IPTC as a block if specified
+    if ($$et{REQ_TAG_LOOKUP}{iptc} or ($$et{TAGS_FROM_FILE} and
+        not $$et{EXCL_TAG_LOOKUP}{iptc}))
+    {
+        if ($pos or $dirLen != length($$dataPt)) {
+            $et->FoundTag('IPTC', substr($$dataPt, $pos, $dirLen));
+        } else {
+            $et->FoundTag('IPTC', $$dataPt);
+        }
     }
     while ($pos + 5 <= $dirEnd) {
@@ -1069,22 +1133,6 @@
                 last unless $remaining =~ /[^\0]/;
             }
-            $exifTool->Warn(sprintf('Bad IPTC data tag (marker 0x%x)',$id));
+            $et->Warn(sprintf('Bad IPTC data tag (marker 0x%x)',$id));
             last;
-        }
-        if (not defined $lastRec or $lastRec != $rec) {
-            my $tableInfo = $tagTablePtr->{$rec};
-            unless ($tableInfo) {
-                $exifTool->Warn("Unrecognized IPTC record $rec, subsequent records ignored");
-                last;   # stop now because we're probably reading garbage
-            }
-            my $tableName = $tableInfo->{SubDirectory}->{TagTable};
-            unless ($tableName) {
-                $exifTool->Warn("No table for IPTC record $rec!");
-                last;   # this shouldn't happen
-            }
-            $recordName = $$tableInfo{Name};
-            $recordPtr = Image::ExifTool::GetTagTable($tableName);
-            $exifTool->VPrint(0,$$exifTool{INDENT},"-- $recordName record --\n");
-            $lastRec = $rec;
         }
         $pos += 5;      # step to after field header
@@ -1093,5 +1141,5 @@
             my $n = $len & 0x7fff; # get num bytes in length field
             if ($pos + $n > $dirEnd or $n > 8) {
-                $exifTool->VPrint(0, "Invalid extended IPTC entry (tag $tag)\n");
+                $et->VPrint(0, "Invalid extended IPTC entry (dataset $rec:$tag, len $len)\n");
                 $success = 0;
                 last;
@@ -1103,7 +1151,27 @@
         }
         if ($pos + $len > $dirEnd) {
-            $exifTool->VPrint(0, "Invalid IPTC entry (tag $tag, len $len)\n");
+            $et->VPrint(0, "Invalid IPTC entry (dataset $rec:$tag, len $len)\n");
             $success = 0;
             last;
+        }
+        if (not defined $lastRec or $lastRec != $rec) {
+            if ($validate and defined $lastRec and $rec < $lastRec) {
+                $et->Warn("IPTC doesn't conform to spec: Records out of sequence",1)
+            }
+            my $tableInfo = $tagTablePtr->{$rec};
+            unless ($tableInfo) {
+                $et->WarnOnce("Unrecognized IPTC record $rec (ignored)");
+                $pos += $len;
+                next;   # ignore this entry
+            }
+            my $tableName = $tableInfo->{SubDirectory}->{TagTable};
+            unless ($tableName) {
+                $et->Warn("No table for IPTC record $rec!");
+                last;   # this shouldn't happen
+            }
+            $recordName = $$tableInfo{Name};
+            $recordPtr = Image::ExifTool::GetTagTable($tableName);
+            $et->VPrint(0,$$et{INDENT},"-- $recordName record --\n");
+            $lastRec = $rec;
         }
         my $val = substr($$dataPt, $pos, $len);
@@ -1113,15 +1181,32 @@
             # - no Format so format is auto-detected
             # - no Name so name is generated automatically with decimal tag number
-            Image::ExifTool::AddTagToTable($recordPtr, $tag, { Unknown => 1 });
+            AddTagToTable($recordPtr, $tag, { Unknown => 1 });
         }
 
-        my $tagInfo = $exifTool->GetTagInfo($recordPtr, $tag);
+        my $tagInfo = $et->GetTagInfo($recordPtr, $tag);
         my $format;
         # (could use $$recordPtr{FORMAT} if no Format below, but don't do this to
         #  be backward compatible with improperly written PhotoMechanic tags)
         $format = $$tagInfo{Format} if $tagInfo;
-        # use logic to determine format if not specified
-        unless ($format) {
+        if (not $format) {
+            # guess at "int" format if not specified
             $format = 'int' if $len <= 4 and $len != 3 and $val =~ /[\0-\x08]/;
+        } elsif ($validate) {
+            my ($fmt,$min,$max);
+            if ($format =~ /(.*)\[(\d+)(,(\d+))?\]/) {
+                $fmt = $1;
+                $min = $2;
+                $max = $4 || $2;
+            } else {
+                $fmt = $format;
+                $min = $max = 1;
+            }
+            my $siz = Image::ExifTool::FormatSize($fmt) || 1;
+            $min *= $siz; $max *= $siz;
+            if ($len < $min or $len > $max) {
+                my $should = ($min == $max) ? $min : ($len < $min ? "$min min" : "$max max");
+                my $what = ($len < $siz * $min) ? 'short' : 'long';
+                $et->Warn("IPTC $$tagInfo{Name} too $what ($len bytes; should be $should)", 1);
+            }
         }
         if ($format) {
@@ -1135,20 +1220,25 @@
                 }
             } elsif ($format =~ /^string/) {
-                $val =~ s/\0+$//;   # some braindead softwares add null terminators
+                # some braindead softwares add null terminators
+                if ($val =~ s/\0+$// and $validate) {
+                    $et->Warn("IPTC $$tagInfo{Name} improperly terminated", 1);
+                }
                 if ($rec == 1) {
                     # handle CodedCharacterSet tag
-                    $xlat = HandleCodedCharset($exifTool, $val) if $tag == 90;
+                    $xlat = HandleCodedCharset($et, $val) if $tag == 90;
                 # translate characters if necessary and special characters exist
                 } elsif ($xlat and $rec < 7 and $val =~ /[\x80-\xff]/) {
                     # translate to specified character set
-                    TranslateCodedString($exifTool, \$val, \$xlat, 1);
+                    TranslateCodedString($et, \$val, \$xlat, 1);
                 }
             } elsif ($format =~ /^digits/) {
-                $val =~ s/\0+$//;
+                if ($val =~ s/\0+$// and $validate) {
+                    $et->Warn("IPTC $$tagInfo{Name} improperly terminated", 1);
+                }
             } elsif ($format !~ /^undef/) {
-                warn("Invalid IPTC format: $format");
+                warn("Invalid IPTC format: $format");   # (this would be a programming error)
             }
         }
-        $verbose and $exifTool->VerboseInfo($tag, $tagInfo,
+        $verbose and $et->VerboseInfo($tag, $tagInfo,
             Table   => $tagTablePtr,
             Value   => $val,
@@ -1160,10 +1250,11 @@
             Format  => $format,
         );
-        $exifTool->FoundTag($tagInfo, $val) if $tagInfo;
+        $et->FoundTag($tagInfo, $val) if $tagInfo;
         $success = 1;
 
         $pos += $len;   # increment to next field
     }
-    delete $exifTool->{SET_GROUP1};
+    delete $$et{SET_GROUP1};
+    delete $$et{LOW_PRIORITY_DIR}{IPTC};
     return $success;
 }
@@ -1190,5 +1281,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/ISO.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/ISO.pm	(revision 34921)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/ISO.pm	(revision 34921)
@@ -0,0 +1,206 @@
+#------------------------------------------------------------------------------
+# File:         ISO.pm
+#
+# Description:  Read information from ISO 9660 disk images
+#
+# Revisions:    2016-04-07 - P. Harvey created
+#
+# References:   1) http://wiki.osdev.org/ISO_9660
+#------------------------------------------------------------------------------
+
+package Image::ExifTool::ISO;
+
+use strict;
+use vars qw($VERSION);
+use Image::ExifTool qw(:DataAccess :Utils);
+
+$VERSION = '1.01';
+
+# trim trailing spaces and ignore tag if empty
+my %rawStr = (
+    RawConv => sub {
+        my $val = shift;
+        $val =~ s/ +$//;
+        return length($val) ? $val : undef;
+    },
+);
+
+# tag info for date/time tags
+my %dateInfo = (
+    Format => 'undef[17]',
+    Groups => { 2 => 'Time' },
+    ValueConv => q{
+        return undef if $val !~ /[^0\0 ]/; # ignore if empty
+        if ($val =~ s/(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})(.)/$1:$2:$3 $4:$5:$6.$7/s) {
+            $val .= TimeZoneString(unpack('c', $8) * 15);
+        }
+        return $val;
+    },
+    PrintConv => '$self->ConvertDateTime($val)',
+);
+
+# lookup for volume descriptor types
+my %volumeDescriptorType = (
+    0 => 'Boot Record',
+    1 => 'Primary Volume',
+    2 => 'Supplementary Volume',
+    3 => 'Volume Partition',
+    255 => 'Terminator',
+);
+
+# ISO tags
+%Image::ExifTool::ISO::Main = (
+    GROUPS => { 2 => 'Other' },
+    NOTES => 'Tags extracted from ISO 9660 disk images.',
+    0 => {
+        Name => 'BootRecord',
+        SubDirectory => { TagTable => 'Image::ExifTool::ISO::BootRecord' },
+    },
+    1 => {
+        Name => 'PrimaryVolume',
+        SubDirectory => { TagTable => 'Image::ExifTool::ISO::PrimaryVolume' },
+    },
+);
+
+%Image::ExifTool::ISO::BootRecord = (
+    GROUPS => { 2 => 'Other' },
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    # 0 => { Name => 'VolumeType', PrintConv => \%volumeDescriptorType }, # (0 for boot record)
+    # 1 => { Name => 'Identifier',      Format => 'undef[5]' }, # (always "CD001")
+    # 6 => 'VolumeDesriptorVersion', # (always 1)
+    # always extract BootSystem, even if empty, as an indication that this is bootable
+      7 => { Name => 'BootSystem',      Format => 'string[32]', ValueConv => '$val=~s/ +$//; $val' },
+    39  => { Name => 'BootIdentifier',  Format => 'string[32]', %rawStr },
+);
+
+%Image::ExifTool::ISO::PrimaryVolume = (
+    GROUPS => { 2 => 'Other' },
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    # 0 => { Name => 'VolumeType', PrintConv => \%volumeDescriptorType }, # (1 for primary volume)
+    # 1 => { Name => 'Identifier',          Format => 'undef[5]' }, # (always "CD001")
+    # 6 => 'VolumeDesriptorVersion', # (always 1)
+      8 => { Name => 'System',              Format => 'string[32]', %rawStr },
+     40 => { Name => 'VolumeName',          Format => 'string[32]', %rawStr },
+     80 => { Name => 'VolumeBlockCount',    Format => 'int32u' },
+    120 => { Name => 'VolumeSetDiskCount',  Format => 'int16u', Unknown => 1 },
+    124 => { Name => 'VolumeSetDiskNumber', Format => 'int16u', Unknown => 1 },
+    128 => { Name => 'VolumeBlockSize',     Format => 'int16u' },
+    132 => { Name => 'PathTableSize',       Format => 'int32u', Unknown => 1 },
+    140 => { Name => 'PathTableLocation',   Format => 'int32u', Unknown => 1 },
+    174 => {
+        Name => 'RootDirectoryCreateDate',
+        Format => 'undef[7]',
+        Groups => { 2 => 'Time' },
+        ValueConv => q{
+            my @a = unpack('C6c', $val);
+            $a[0] += 1900;
+            $a[6] = TimeZoneString($a[6] * 15);
+            return sprintf('%.4d:%.2d:%.2d %.2d:%.2d:%.2d%s', @a);
+        },
+        PrintConv => '$self->ConvertDateTime($val)',
+    },
+    190 => { Name => 'VolumeSetName',       Format => 'string[128]', %rawStr },
+    318 => { Name => 'Publisher',           Format => 'string[128]', %rawStr },
+    446 => { Name => 'DataPreparer',        Format => 'string[128]', %rawStr },
+    574 => { Name => 'Software',            Format => 'string[128]', %rawStr },
+    702 => { Name => 'CopyrightFileName',   Format => 'string[38]', %rawStr },
+    740 => { Name => 'AbstractFileName',    Format => 'string[36]', %rawStr },
+    776 => { Name => 'BibligraphicFileName',Format => 'string[37]', %rawStr },
+    813 => { Name => 'VolumeCreateDate',    %dateInfo },
+    830 => { Name => 'VolumeModifyDate',    %dateInfo },
+    847 => { Name => 'VolumeExpirationDate',%dateInfo },
+    864 => { Name => 'VolumeEffectiveDate', %dateInfo },
+   #881 => 'FileStructureVersion', # (always 1)
+);
+
+# ISO Composite tags
+%Image::ExifTool::ISO::Composite = (
+    GROUPS => { 2 => 'Other' },
+    VolumeSize => {
+        Require => {
+            0 => 'ISO:VolumeBlockCount',
+            1 => 'ISO:VolumeBlockSize',
+        },
+        ValueConv => '$val[0] * $val[1]',
+        PrintConv => \&Image::ExifTool::ConvertFileSize,
+    },
+);
+
+# add our composite tags
+Image::ExifTool::AddCompositeTags('Image::ExifTool::ISO');
+
+#------------------------------------------------------------------------------
+# Extract information from an ISO 9660 disk image
+# Inputs: 0) ExifTool object reference, 1) dirInfo reference
+# Returns: 1 on success, 0 if this wasn't a valid ISO 9660 image
+sub ProcessISO($$)
+{
+    my ($et, $dirInfo) = @_;
+    my $raf = $$dirInfo{RAF};
+    my ($buff, $tagTablePtr);
+
+    # verify this is a valid ISO file
+    return 0 unless $raf->Seek(32768, 0);
+
+    while ($raf->Read($buff, 2048) == 2048) {
+        last unless $buff =~ /^[\0-\x03\xff]CD001/;
+        unless ($tagTablePtr) {
+            $et->SetFileType(); # set the FileType tag
+            SetByteOrder('II'); # read little-endian values only
+            $tagTablePtr = GetTagTable('Image::ExifTool::ISO::Main');
+        }
+        my $type = unpack('C', $buff);
+        $et->VPrint(0, "Volume descriptor type $type ($volumeDescriptorType{$type})\n");
+        last if $type == 255;   # stop at terminator
+        next unless $$tagTablePtr{$type};
+        my $subTablePtr = GetTagTable($$tagTablePtr{$type}{SubDirectory}{TagTable});
+        my %dirInfo = (
+            DataPt   => \$buff,
+            DataPos  => $raf->Tell() - 2048,
+            DirStart => 0,
+            DirLen   => length($buff),
+        );
+        $et->ProcessDirectory(\%dirInfo, $subTablePtr);
+    }
+    return $tagTablePtr ? 1 : 0;
+}
+
+1;  # end
+
+__END__
+
+=head1 NAME
+
+Image::ExifTool::ISO - Read information from ISO 9660 disk images
+
+=head1 SYNOPSIS
+
+This module is used by Image::ExifTool
+
+=head1 DESCRIPTION
+
+This module contains definitions required by Image::ExifTool to read
+information from ISO 9660 disk images.
+
+=head1 AUTHOR
+
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
+
+This library is free software; you can redistribute it and/or modify it
+under the same terms as Perl itself.
+
+=head1 REFERENCES
+
+=over 4
+
+=item L<http://wiki.osdev.org/ISO_9660>
+
+=back
+
+=head1 SEE ALSO
+
+L<Image::ExifTool::TagNames/ISO Tags>,
+L<Image::ExifTool(3pm)|Image::ExifTool>
+
+=cut
+
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/ITC.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/ITC.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/ITC.pm	(revision 34921)
@@ -16,5 +16,5 @@
 use Image::ExifTool qw(:DataAccess :Utils);
 
-$VERSION = '1.00';
+$VERSION = '1.02';
 
 sub ProcessITC($$);
@@ -69,5 +69,5 @@
         Name => 'ImageType',
         Format => 'undef[4]',
-        PrintConv => {
+        ValueConv => { # (not PrintConv because the unconverted JPEG value is nasty)
             'PNGf' => 'PNG',
             "\0\0\0\x0d" => 'JPEG',
@@ -84,5 +84,5 @@
 sub ProcessITC($$)
 {
-    my ($exifTool, $dirInfo) = @_;
+    my ($et, $dirInfo) = @_;
     my $raf = $$dirInfo{RAF};
     my $rtnVal = 0;
@@ -106,5 +106,5 @@
             last unless $tag eq 'itch';
             last unless $size >= 0x1c and $size < 0x10000;
-            $exifTool->SetFileType();
+            $et->SetFileType();
             SetByteOrder('MM');
             $rtnVal = 1;    # this is an ITC file
@@ -122,5 +122,5 @@
             );
             my $tagTablePtr = GetTagTable('Image::ExifTool::ITC::Header');
-            $exifTool->ProcessDirectory(\%dirInfo, $tagTablePtr);
+            $et->ProcessDirectory(\%dirInfo, $tagTablePtr);
         } elsif ($tag eq 'item') {
             # don't want to read the entire item data (includes image)
@@ -142,5 +142,5 @@
             $raf->Read($buff, $len) == $len or last;
             unless ($len >= 0xb4 and substr($buff, 0xb0, 4) eq 'data') {
-                $exifTool->Warn('Parsing error. Please submit this ITC file for testing');
+                $et->Warn('Parsing error. Please submit this ITC file for testing');
                 last;
             }
@@ -151,12 +151,12 @@
             );
             $tagTablePtr = GetTagTable('Image::ExifTool::ITC::Item');
-            $exifTool->ProcessDirectory(\%dirInfo, $tagTablePtr);
+            $et->ProcessDirectory(\%dirInfo, $tagTablePtr);
             # extract embedded image
             $pos += $len;
             if ($size > 0) {
                 $tagTablePtr = GetTagTable('Image::ExifTool::ITC::Main');
-                my $tagInfo = $exifTool->GetTagInfo($tagTablePtr, 'data');
-                my $image = $exifTool->ExtractBinary($pos, $size, $$tagInfo{Name});
-                $exifTool->FoundTag($tagInfo, \$image);
+                my $tagInfo = $et->GetTagInfo($tagTablePtr, 'data');
+                my $image = $et->ExtractBinary($pos, $size, $$tagInfo{Name});
+                $et->FoundTag($tagInfo, \$image);
                 # skip the rest of the block if necessary
                 $raf->Seek($pos+$size, 0) or last
@@ -165,9 +165,9 @@
             }
         } else {
-            $exifTool->VPrint(0, "Unknown $tag block ($size bytes)\n");
+            $et->VPrint(0, "Unknown $tag block ($size bytes)\n");
             $raf->Seek($size-8, 1) or last;
         }
     }
-    $err and $exifTool->Warn('ITC file format error');
+    $err and $et->Warn('ITC file format error');
     return $rtnVal;
 }
@@ -192,5 +192,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
